"""JARVIS Admin Cogs."""
import logging

from naff import Client

from jarvis.cogs.admin import (
    ban,
    kick,
    lock,
    lockdown,
    modcase,
    mute,
    purge,
    roleping,
    warning,
)


def setup(bot: Client) -> None:
    """Add admin cogs to JARVIS"""
    logger = logging.getLogger(__name__)
    msg = "Loaded jarvis.cogs.admin.{}"
    ban.BanCog(bot)
    logger.debug(msg.format("ban"))
    kick.KickCog(bot)
    logger.debug(msg.format("kick"))
    lock.LockCog(bot)
    logger.debug(msg.format("lock"))
    lockdown.LockdownCog(bot)
    logger.debug(msg.format("lockdown"))
    modcase.CaseCog(bot)
    logger.debug(msg.format("modcase"))
    mute.MuteCog(bot)
    logger.debug(msg.format("mute"))
    purge.PurgeCog(bot)
    logger.debug(msg.format("purge"))
    roleping.RolepingCog(bot)
    logger.debug(msg.format("roleping"))
    warning.WarningCog(bot)
    logger.debug(msg.format("warning"))
